#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

#include "plugin.h"

extern void
aaa(void)
{
	printf("The aaa() has been executed\n");
}

int
main(int argc, char **argv)
{
	struct plugin_data *pd;
	void *hdl;
	void *obj;
	int error;

	hdl = dlopen("plugin/plugin.so", RTLD_LAZY);
	if (hdl == NULL) {
		fprintf(stderr, "dlopen failed: %s\n", dlerror());
		exit(EXIT_FAILURE);
	}
	pd = (struct plugin_data *)dlsym(hdl, "plugin_data");
	if (pd == NULL) {
		fprintf(stderr, "dlsym %s\n", dlerror());
		exit(EXIT_FAILURE);
	}
	pd->plug_in(10);
	pd->plug_out(20);
	error = dlclose(hdl);
	if (error) {
		fprintf(stderr, "dlclose(): %s\n", dlerror());
		exit(EXIT_FAILURE);
	}
	exit(EXIT_SUCCESS);
}
